package LightController;

import java.io.IOException;

import java.util.concurrent.TimeUnit;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.Condition;

import TronAdapter.TronAdapter;
import TronAdapter.TronReporter;
import TronAdapter.TronException;

class TestFixture implements LevelListener, TronAdapter
{
    int testIGrasp = 0;
    int testIRelease = 0;

    int testOSetLevel = 0;

    LightController lc = null;

    TronReporter reporter = null;

    int[] pLevel = new int[1];
    int[] pEmpty = new int[0];

    public TestFixture(int portNumber, LightController lc)
    {
	this.lc = lc;
	reporter = new TronReporter(this, portNumber);
    }

    public void levelChanged(int level)
    {
	pLevel[0] = level;
	reporter.report(testOSetLevel, pLevel);
    }

    public void configure(TronReporter reporter)
	throws TronException, IOException
    {
	testIGrasp = reporter.addInput("grasp");
	testIRelease = reporter.addInput("release");
	testOSetLevel = reporter.addOutput("level");
	reporter.addVarToOutput(testOSetLevel, "adapLevel");
	reporter.setTimeUnit(10000);
	reporter.setTimeout(1000000);
    }

    public void interrupt()
    {
	reporter.disconnect();
    }

    public void perform(int chan, int[] params)
    {
	if (chan == testIGrasp) {
	    System.out.println("TestFixture: GRASP");
	    lc.handleGrasp();
	} else if (chan == testIRelease) {
	    System.out.println("TestFixture: RELEASE");
	    lc.handleRelease();
	} else {
	    System.out.println("TestFixture: UNKNOWN");
	}
    } /* perform() */
} /* class TestFixture */
